mod api;
mod cli;
mod config;
pub mod db;
mod distro;
mod error;
mod repo;

pub use error::{Result, ServerError};
use repo::DistroMgr;

use clap::Parser;
use std::{path::PathBuf, sync::Arc};

pub const ANY_ARCH: &'static str = "any";

#[derive(Clone)]
pub struct Config {
    data_dir: PathBuf,
}

#[derive(Clone)]
pub struct Global {
    config: Config,
    mgr: Arc<repo::RepoMgr>,
    db: sea_orm::DbConn,
}

#[tokio::main]
async fn main() -> crate::Result<()> {
    let cli = cli::Cli::parse();
    cli.run().await
}
